/*

** statsum.d

** Copyright (C) 2003 Helmut Leitner

** Donated to Digital Mars.

** Released under the GNU GPL, see LICENSE.TXT

** and http://www.gnu.org/copyleft/gpl.html

*/



module venus.statsum;

import venus.all;



class StatSum {

  double sum=0.0;

  double sum_squares=0.0; /* sum of val*val */

  int n=0;



  void Clear() {

    sum=0.0;

    sum_squares=0.0;

    n=0;

  }



  void AddVal(double x) {

    sum+=x;

    sum_squares+=(x*x);

    n+=1;

  }



  void AddValCount(double x,int n) {

    sum+=(n*x);

    sum_squares+=(n*x*x);

    n+=n;

  }



  void GetMean(double *pmean) {

    if(n<1) {

      *pmean=0.0;

    } else {

      *pmean=sum/n;

    }

  }



  double RetMean() {

    double mean;

    GetMean(&mean);

    return mean;

  }



  error GetDeviation(double *pdeviation) {

    if(n<2) {

      *pdeviation=0.0;

      return -1;

    }

    *pdeviation=sqrt((sum_squares - sum*sum/n)/(n-1));

    return 0;

  }



  double RetDeviation()

  {

    double deviation;

    GetDeviation(&deviation);

    return deviation;

  }



  void GetMeanDeviation(double *pmean,double *pdeviation) {

    GetMean(pmean);

    GetDeviation(pdeviation);

  }

}



